'-------------------------------- Data06 ---------------------------------'
'                                                                         '
' This program 'converts' a single precision value to a 4-byte array.     '
' The array is then displayed in hex format.                              '
'                                                                         '
'-------------------------------------------------------------------------'

'global declarations
'integers
DIM byte(4)     AS INTEGER              'byte array

'longs
DIM counter     AS LONG                 'byte array counter
DIM addr        AS LONG                 'address of variable solution

'singles
DIM soln        AS SINGLE               'single value to convert

'strings
'DIM byte(4)     AS STRING * 1           'byte array

runagain:

'clear the screen
CLS


'display message
INPUT "Enter Single Precision value and press <enter>:  "; soln
PRINT

'get address of single prec. value
addr = VARPTR(soln)

FOR counter = 0 TO 3

	byte(counter) = PEEK(addr + counter)

NEXT counter


'display the result
PRINT "Single Precision Value in Hex:  0x  ";

FOR counter = 3 TO 0 STEP -1

       
	IF byte(counter) < 16 THEN

		PRINT "0"; HEX$(byte(counter)); " ";

	ELSE
       
		PRINT HEX$(byte(counter)); " ";

	END IF

NEXT counter

PRINT


' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press <A> to run again, Press any other key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'if user enters A or a, jump up 'top'
IF A$ = "A" OR A$ = "a" THEN GOTO runagain

'end when keylatch contains any key but A
END

