VERSION 5.00
Begin VB.Form frmFunction03 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Function03-Demo Calling Time vs. # Parameters"
   ClientHeight    =   3240
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5010
   Icon            =   "frmFunction03.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3240
   ScaleWidth      =   5010
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClearText 
      Caption         =   "Clear Text"
      Height          =   495
      Left            =   3720
      TabIndex        =   3
      Top             =   2280
      Width           =   1215
   End
   Begin VB.CommandButton cmdEightPassed 
      Caption         =   "Eight Doubles Passed"
      Height          =   495
      Left            =   3720
      TabIndex        =   2
      Top             =   1560
      Width           =   1215
   End
   Begin VB.CommandButton cmdFourParam 
      Caption         =   "Four Doubles Passed"
      Height          =   495
      Left            =   3720
      TabIndex        =   1
      Top             =   840
      Width           =   1215
   End
   Begin VB.CommandButton cmdTwoParam 
      Caption         =   "Two Doubles Passed"
      Height          =   495
      Left            =   3720
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmFunction03"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the performance cost of passing
'parameters to functions.  To illustrate this, functions
'are called that accept 2, 4, and 8 parameters.
'
'The called functions do no work, but simply return a value.

Option Explicit

'global declarations
'constants
Const cNumIts As Long = 100000000       'number of iterations


'function that accepts two double parameters
Private Function TwoParam(ByVal p1 As Double, ByVal p2 As Double) As Double

    'return a value
    TwoParam = 0

End Function

'function that accepts four double paramters
Private Function FourParam(ByVal p1 As Double, _
    ByVal p2 As Double, ByVal p3 As Double, _
    ByVal p4 As Double) As Double
    
    'return a value
    FourParam = 0
    
End Function

'function that accepts eight double parameters
Private Function EightParam(ByVal p1 As Double, _
    ByVal p2 As Double, ByVal p3 As Double, _
    ByVal p4 As Double, ByVal p5 As Double, _
    ByVal p6 As Double, ByVal p7 As Double, _
    ByVal p8 As Double) As Double

    'return a value
    EightParam = 0

End Function

'clears the display area
Private Sub cmdClearText_Click()

    Cls

End Sub

'passes eight double parameters to a function
Private Sub cmdEightPassed_Click()

    'local declarations
    'longs
    Dim Counter As Long             'iteration counter
    
    'singles
    Dim StartTimer As Single        'ticks at start of loop
    Dim StopTimer As Single         'ticks at loop exit
    
    'doubles
    Dim Dummy As Double             'function return value
    
    'start the timer
    StartTimer = Timer
    
    For Counter = 1 To cNumIts
        
        'call the eight parameter function with eight parameters
        Dummy = EightParam(0, 0, 0, 0, 0, 0, 0, 0)
    
    Next Counter
    
    'stop the timer
    StopTimer = Timer

    'display the result
    Print "Called Eight Parameter Function"
    Print "passing Eight parameters in"
    Print StopTimer - StartTimer; " seconds."
    Print


End Sub

'passes four doubles to function
Private Sub cmdFourParam_Click()

    'local declarations
    'longs
    Dim Counter As Long             'iteration counter
    
    'singles
    Dim StartTimer As Single        'ticks at start of loop
    Dim StopTimer As Single         'ticks at loop exit
    
    'doubles
    Dim Dummy As Double             'return value for function
    
    'start the timer
    StartTimer = Timer
    
    For Counter = 1 To cNumIts
    
        'call the four parameter function passing four doubles
        Dummy = FourParam(0, 0, 0, 0)
    
    Next Counter
    
    'stop the timer
    StopTimer = Timer

    'display the result
    Print "Called Four Parameter Function"
    Print "passing Four parameters in"
    Print StopTimer - StartTimer; " seconds."
    Print


End Sub

'passes two doubles to function
Private Sub cmdTwoParam_Click()

    'local declaratations
    'longs
    Dim Counter As Long             'iteration counter
    
    'singles
    Dim StartTimer As Single        'ticks at start of loop
    Dim StopTimer As Single         'ticks at loop exit
    
    'doubles
    Dim Dummy As Double             'return value of function
    
    'start the timer
    StartTimer = Timer
    
    For Counter = 1 To cNumIts
    
        'pass two doubles to the two parameter function
        Dummy = TwoParam(0, 0)
    
    Next Counter
    
    'stop the timer
    StopTimer = Timer

    'display the result
    Print "Called Two Parameter Function"
    Print "passing Two parameters in"
    Print StopTimer - StartTimer; " seconds."
    Print

End Sub
