// Data06.c : implementation file
//
// This program extracts byte fields from single precision floating point
// data.  The memcpy() function is used.
//
// fnA() performs the work


#include <sys/time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


//functions
void fnA();						

// compute using LOCAL scope
void fnA()
{	
	//locals
	//floats
	float inputvalue;		// value entered by user
	
	//character strings
	char byte1[4];			// byte string, in hex 
	

	//display entry message
	printf("\nEnter single precision floating point value: ");

	//get the value
	scanf("%g", &inputvalue);
	
	memcpy(byte1, &inputvalue, 4);


	//display the result
	printf("%s%g%s", "\n\nByte fields for ", inputvalue, " in hex:\n");
	printf("%s%.2hhX %.2hhX %.2hhX %.2hhX", "0x",byte1[3],byte1[2], byte1[1], byte1[0]);
	printf("\n\n");
}//end fnA()


//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("clear");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\tExtract byte field data from a float\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//call the user selected function
		switch	(inchar){

			case '1': fnA();
				break;
	
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

}
