'-------------------------------- Data04 ---------------------------------'
'                                                                         '
' This program compares floating point (/) to integer (\) division.       '
'                                                                         '
' NOTE: Iteration Loops are smaller than the Visual Basic and C examples  '
'       by a factor of ten.                                               '
'                                                                         '
'-------------------------------------------------------------------------'

'global declarations
'longs
DIM counter     AS LONG         'iteration counter
DIM iResult     AS LONG         'integer result

'singles
DIM timestart   AS SINGLE       'ticks at start of loop
DIM timestop    AS SINGLE       'ticks at loop exit

'doubles
DIM x           AS DOUBLE       'base
DIM y           AS DOUBLE       'exponent

'clear the screen
CLS


'-------------------- Float Operands with Type Conversion --------------

'display message
PRINT "Starting float division with float operands ..."
PRINT


'start the timer
timestart = TIMER


FOR counter = 1 TO 10000000

	'compute float division with float operands, convert to integer
	'after computation
	iResult = INT(100! / 3!)
 
NEXT counter

'stop the timer
timestop = TIMER

'display the result
PRINT "Computed int(float/float) in "; timestop - timestart; " seconds"
PRINT

'---------------End Float Division with Float Operands Calculation ---------

'-------------------- Integer Operands Float Division ----------------------

'display message
PRINT "Starting float division with integer operands ..."
PRINT


'start the timer
timestart = TIMER


FOR counter = 1 TO 10000000

	'using floating point operator, and integer
	'operands
	iResult = 100 / 3

NEXT counter

'stop the timer
timestop = TIMER

'display the result
PRINT "Computed (int/int) in "; timestop - timestart; " seconds"
PRINT

'---------End Float Division with Integer Operands Calculation ---------

'----------------- Integer Division with Integer Operands --------------

'display message
PRINT "Starting integer division with integer operands ..."
PRINT


'start the timer
timestart = TIMER


FOR counter = 1 TO 10000000

	'compute integer division with integer operands
	iResult = INT(100 \ 3)
 
NEXT counter

'stop the timer
timestop = TIMER

'display the result
PRINT "Computed (int\int) in "; timestop - timestart; " seconds"
PRINT

'---------------End Float Division with Float Operands Calculation ---------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

