VERSION 5.00
Begin VB.Form frmData06 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Data06 - Convert Single Precision to Byte Array"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "Data06.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command2 
      Caption         =   "Clear Text"
      Height          =   615
      Left            =   3000
      TabIndex        =   2
      Top             =   2280
      Width           =   1455
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Right Justify
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Text            =   "6.0"
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Convert"
      Height          =   615
      Left            =   3000
      TabIndex        =   0
      Top             =   1440
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Enter Single Precision Value to Convert to Hex Bytes"
      Height          =   615
      Left            =   2760
      TabIndex        =   3
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "frmData06"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program converts a single precision floating point
'value stored in memory to a 4 byte array.  This routine
'will be used for the raw parallel demo's in Chapter 12.
'
'The non-documented VarPtr function is used to obtain the
'address of a variable.
'
'The Win32 API function CopyMemory is used to move individual
'bytes, pointed to by VarPtr, into the byte array.
'
'The resulting four bytes are displayed in Hexadecimal.
'
'The reader is encouraged to verify these conversions.

Option Explicit

'converts the floating point value entered (as a string) in
'the text box to an array of four bytes.
Private Sub Command1_Click()

    'local declarations
    'singles
    Dim Soln As Single              'this is the value to convert
    
    'strings
    Dim AString As String * 2       'output string
    
    'bytes
    Dim ByteArray() As Byte         'array of four bytes

    'get the value entered in Text1
    Soln = Val(Text1.Text)
    
    'call the conversion function; returns an array of four bytes
    ByteArray() = sFloat2ByteArray(Soln)
    
    'build the output string
    'note the order! lsB/msB is important here!
    AString = Hex(ByteArray(3))
    If ByteArray(3) < 16 Then AString = "0" & AString
    Print AString & " ";
    AString = Hex(ByteArray(2))
    If ByteArray(2) < 16 Then AString = "0" & AString
    Print AString & " ";
    AString = Hex(ByteArray(1))
    If ByteArray(1) < 16 Then AString = "0" & AString
    Print AString & " ";
    AString = Hex(ByteArray(0))
    If ByteArray(0) < 16 Then AString = "0" & AString
    Print AString & " ";
    Print "H"

End Sub

'function to perform the actual conversion; a quad word
'variable (float) as an input value and extracts the individual
'bytes.
Private Function sFloat2ByteArray(ByVal qWord As Single) As Byte()

    'local declarations
    'bytes
    Dim AByte(4) As Byte

    Dim Count

    'calls to API CopyMemory Function
    CopyMemory AByte(0), ByVal VarPtr(qWord), 4
    
    'return the byte array
    sFloat2ByteArray = AByte

End Function

'Clears the display area
Private Sub Command2_Click()

    Cls

End Sub
