VERSION 5.00
Begin VB.Form frmFunction08 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Function08 - Recursive vs. Iterative Function"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5085
   Icon            =   "Function08.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   5085
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Text"
      Height          =   735
      Left            =   3720
      TabIndex        =   2
      Top             =   2160
      Width           =   1215
   End
   Begin VB.CommandButton cmdCalcFact 
      Caption         =   "Compute Factorial in Do Loop"
      Height          =   735
      Left            =   3720
      TabIndex        =   1
      Top             =   1200
      Width           =   1215
   End
   Begin VB.CommandButton cmdFactRecurs 
      Caption         =   "Compute Factorial by Recursive call"
      Height          =   735
      Left            =   3720
      TabIndex        =   0
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "frmFunction08"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const cNumIts As Long = 1000000

Dim starttimer As Single
Dim stoptimer As Single


Private Sub cmdCalcFact_Click()

    Dim fact As Long
    Dim counter As Long
    Dim factval As Long
    
    Dim factorial As Double
    
    factval = 100
    
    starttimer = Timer
    
    For counter = 1 To cNumIts
    
        fact = 1
        factorial = 1
        
        Do While fact <= factval
        
            factorial = factorial * fact
            
            fact = fact + 1
    
        Loop
        
    Next counter
    
    stoptimer = Timer
    
    
    Print "Computed in Do Loop "; cNumIts; " times"
    Print "100! = "; factorial
    Print "Time: "; stoptimer - starttimer
    Print
    
End Sub


Private Sub cmdClear_Click()

    Cls

End Sub

Private Sub cmdFactRecurs_Click()

    Dim counter As Long
    
    Dim factorial As Double
    
    starttimer = Timer
    
    For counter = 1 To cNumIts
    
        factorial = Recurs_Fact(100)
    
    Next counter
    
    stoptimer = Timer
    
    Print "Computed Factorial Recursively "; cNumIts; " times"
    Print "100! = "; factorial
    Print "Time: "; stoptimer - starttimer
    Print
    
End Sub

Private Function Recurs_Fact(Arg1 As Long) As Double

    Dim answer As Double

    If Arg1 = 1 Then
    
         Recurs_Fact = 1
         Exit Function
         
    Else
    
        answer = Recurs_Fact(Arg1 - 1) * Arg1

    End If

    Recurs_Fact = answer

End Function

