// Function01Dlg.cpp : implementation file
//

// This program compares the performance of calling a function with
// using inline code.  The functions are empty and do no work.


#include "stdafx.h"
#include "Function01.h"
#include "Function01Dlg.h"
#include "math.h"
#include "stdio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// global declarations
static int cNumIts = 10000000;

double calc_ljenergy(double R);

/////////////////////////////////////////////////////////////////////////////
// CFunction01Dlg dialog

CFunction01Dlg::CFunction01Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunction01Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunction01Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunction01Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunction01Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunction01Dlg, CDialog)
	//{{AFX_MSG_MAP(CFunction01Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunction01Dlg message handlers

BOOL CFunction01Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunction01Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunction01Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//repetively calls the function calc_ljenergy(double r),
//which for this demo does no work, just returns a value of 0
void CFunction01Dlg::OnButton1() 
{

    //Local Declarations
	//Integers
	int counter;
	int j;

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double r;                 //distance, a double to pass to function
    double energy;            //energy, holder for function return value
    
	//characters
	char buffer[200];		//output string


    r = 0;                           //just a value to pass
    
    starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

        energy = calc_ljenergy(r);   //call the function, passing a double and
                                     //returning a double

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly called function 10,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	


}

double calc_ljenergy (double R)
{

	double R1;		//these would be used internally in the 
	double R2;		//optimized lj energy computation

	return(0);

}


//Function to do the loop as inline code
void CFunction01Dlg::OnButton2() 
{

	//Local Declarations
	//Integers
	int counter;
	int j;

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double r;                 //distance, a double to pass to function
	double r1;				  //holder variable, would be used in energy calc
	double r2;				  //holder variable, would be used in energy calc
    double energy;            //energy, holder for function return value
    
	//characters
	char buffer[200];		//output string


    r = 0;                           //just a value to pass
    
    starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

        //no work is actually done
		//no parameters or return values passed

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Loop with no function call 10,000,000 times %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	


}
