// Function07Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Function07.h"
#include "Function07Dlg.h"
#include "stdio.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//globals
const int cNumIts = 50000000;

/////////////////////////////////////////////////////////////////////////////
// CFunction07Dlg dialog

CFunction07Dlg::CFunction07Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunction07Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunction07Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunction07Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunction07Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunction07Dlg, CDialog)
	//{{AFX_MSG_MAP(CFunction07Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunction07Dlg message handlers

BOOL CFunction07Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunction07Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunction07Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//compute random numbers using the intrinsic RAND() function
void CFunction07Dlg::OnButton1() 
{
	
	//Local Declarations
	//Integers
	int counter;			//iteration counter
	int j;					//buffer position pointer
	int rnum;				//random number return value

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
    
	//characters
	char buffer[200];		//output string


	starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

        //get a random number
		rnum = rand();

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Got 50,000,000 random numbers in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "RAND() Random Numbers",
				MB_OK | MB_ICONEXCLAMATION);
	


}


//Compute Random Numbers using inline code
void CFunction07Dlg::OnButton2() 
{
	
	//Local Declarations
	//Integers
	int counter;			//iteration counter
	int j;					//buffer position pointer
	int xk;					//last value
	int rnum;				//random number return value

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
    
	//characters
	char buffer[200];		//output string


	starttime = GetTickCount();		//start the timer

	//seed the generator
    xk = 200;

	for(counter=1; counter <= cNumIts; ++counter){
        
        //compute the next pseudo random number in the sequence
		rnum = (25*xk) % 16777216;

        //"increment" the recursive index
        xk = rnum;

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Computed 50,000,000 random numbers in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Inline Coded Random Numbers",
				MB_OK | MB_ICONEXCLAMATION);
	
	
}
